<?php
  // $Id: ed_classified_views.inc,v 1.1.2.1 2007/08/12 08:00:29 inactivist Exp $

  /**
   * Simple text-based classified ads module.
   * Michael Curry, Exodus Development, Inc.
   * exodusdev@gmail.com
   * for more information, please visit http://exodusdev.com/drupal/modules/classified.module
   * Copyright (c) 2006, 2007 Exodus Development, Inc.  All Rights Reserved. 
   * Licensed under the terms of the GNU Public License (GPL) version 2.  Please see LICENSE.txt for
   * license terms.  Possession and use of this code signifies acceptance of license
   * terms.
   */


/* ================= views.module integration ===================== */

/**
 * Experimental views integration - no guarantees express or implied.  
 * Use at your own risk.
 * See: http://drupal.org/node/42609
 */
function ed_classified_views_tables() {
  $parms = _ed_classified_displayname_parms();
  $parms['!modulename'] = EDI_CLASSIFIED_MODULE_NAME;

  $tables['edi_classified_nodes'] 
    = array('name' => 'edi_classified_nodes',
            'join' => 
               array('left' => 
                     array('table' => 'node',
                           'field' => 'nid' ),
                            'right' => 
                     array('field' => 'nid')),
            'fields' => array('expires_on' 
                              => array('name' => t('!modulename: Ad Expiration', $parms),
                                       'handler' => array('views_handler_field_date' => 'As Date', 
                                                          'views_handler_field_date_custom' => 'As Custom Date'),
                                       'sortable' => true),
                              'expires_on_delta' => array('name' => t('!modulename: Ad Expiration delta from current time', $parms),
                                        'handler' => array('classified_views_handler_ad_expiration_delta' => 'As Interval', 
                                                           'views_handler_field_date_custom' => 'As Custom Date'),
                                        'sortable' => true,
                                        'notafield' => true,
                                        ),
                              ),
            );
  return $tables;
}

/**
 * Views handler for expiration 'delta' from current time
 */
function ed_classified_views_handler_ad_expiration_delta($fieldinfo, $fielddata, $value, $data) {
  $value = $data->edi_classified_nodes_expires_on;
  $time_now = time();
  $delta = $value ? $value - $time_now : 0;
  return format_interval($delta);
}




/* ================= views.module integration END  ===================== */
